SuperStrict

Const GW:Int = 1024,GH:Int = 720

Graphics GW,GH	
SeedRnd MilliSecs()
Global Mapsize:Int = 800

Include "System.bmx"
Include "FileParser.bmx"

Include "TGameObjekt.bmx"
Include "TCell.bmx"
Include "TNode.bmx"
Include "TOrganelle.bmx"
Include "TItem.bmx"
Include "TSkill.bmx"
Include "TDGameObjekt.bmx"
Include "TVirus.bmx"
Include "TEnzyme.bmx"
Include "TBlubb.bmx"
Include "TMessage.bmx"
Include "TGui.bmx"
Include "TToxin.bmx"


Global ScreenX:Int,ScreenY:Int,Cell:TCell
Global SkillTree:Tree = ReadSkill()
Skilltree.GivePositions(100,100,600,400)
Global BigFont:TimageFont 	= LoadImageFont("gfx/font.ttf",64)
Global SmallFont:TimageFont 	= LoadImageFont("gfx/font.ttf",16)
Global Channel:TChannel,ChannelVolumen:Float = 0.75
Main()

Function Main()
Cls
	SetBlend Alphablend
	SetImageFont(BigFont)
	text2 "Phage",GW/2,GH/4,1,1
	SetImageFont(Smallfont)	
	text2 "Bereite Experiment vor...",GW/2,GH/2,1,1
	Flip
	Channel:TChannel = PlaySound(LoadSound("sfx/music.ogg",SOUND_LOOP))
	channel.setvolume(ChannelVolumen)
	
	Local FY:Int = GH
	Repeat
		DrawBackGroundTree(Fy,51,204,204)
		Fy = Max(Fy -2,0)
		SetImageFont(BigFont)
		text2 "Phage",GW/2,GH/4,1,1
		SetImageFont(SmallFont)
		text2 "Klicke um zu starten",GW/2,GH/2,1,1
		MouseUpdate()
		If maus1 
			GameLoop()
			Celllist.clear()
			Virenlist.clear()
			Insidevirenlist.clear()
			itemlist.clear()
			guilist.clear()
		EndIf
		Flip
		Cls
	Until AppTerminate()
End Function

Function GetTime(S:String)
	Global Time:Int = MilliSecs()
	If MilliSecs() - Time > 5 And s <> "Flip" Then DebugLog "Timer: " + s + " " + (MilliSecs() - Time)
	Time = MilliSecs()
End Function

Function GameLoop()
	Blubblist.clear()
	Local Timer:TTimer = CreateTimer(60)
	Cell = CreateCell(GraphicsWidth()/2,GraphicsHeight()/2,50,0)
	cell.resourcen[ATP] = 500
	cell.LifeGui = CreateGui(LifeAnzeige)
	
	GetMessages()
	Repeat
		If KeyHit(KEY_O) Then cell.life = 0
		GetTime("Flip")

		
		DrawBackground()
		
		MouseUpdate()

		fps(0,0)
		GetTime("Hintergrund und MouseUpdate")
		
		UpdateCells()
		GetTime("Zellen")
		
		UpdateViren()
		GetTime("Viren")
		
		UpdateItems()
		GetTime("Items")

		DrawGui()
		GetTime("GUI")
		
		UpdateMessage()
		GetTime("Nachrichten")
		
		UpdateToxin()
		
		Blubbs(-1,0.5,-20)
		GetTime("Blubbs")
		
		DefendCell()
		GetTime("Defend")
		
		UpdateProduktion()
		GetTime("Produktion")
		
		UpdateMovingText()
		GetTime("Bewegete Texte")
		
		Controll()
		GetTime("Steuerung")
		
		If KeyHit(KEY_SPACE) Then TreeMain()
		If KeyHit(KEY_N) Then 
			ChannelVolumen = Min(ChannelVolumen + 0.1,1)
			Channel.SetVolume(ChannelVolumen)
			CreateMovingText("Lautstrke: " + Int(ChannelVolumen* 100) + "%",GW/2,GH/2)
		ElseIf KeyHit(KEY_M)
			ChannelVolumen = Max(ChannelVolumen - 0.1,0)
			Channel.SetVolume(ChannelVolumen)
			CreateMovingText("Lautstrke: " + Int(ChannelVolumen* 100) + "%",GW/2,GH/2)
		EndIf
		
		Flip
		Cls
		If AppTerminate() Then End
		WaitTimer(Timer)
	Until KeyHit(KEY_ESCAPE)
End Function

Function DrawBackground()
	Global image:TImage = imageload("Textur")
		For Local x:Int = -6 To 6
			For Local y:Int = -6 To 6
				DrawImage image,340 * x - (screenx Mod Gw) + 680, 340 * y - (screeny Mod gh) + 680
			Next
		Next
End Function

Function Controll()
Global GotX:Int = Cell.x,GotY:Int = cell.y,AimRotation:Int,AimImage:TImage = imageload("aim")
Global AimX:Int = GotX,AimY:Int = GotY,	LastMove:Int,LastExecute:Int,NewMove:Byte
		
		Screenx = Cell.x - Gw/2
		Screeny = Cell.y - Gh/2
		
		Local CX:Int = Cell.x - (GotX + screenx)
		Local CY:Int = Cell.y - (GotY + Screenx) 
		If  Cx * Cx + Cy * Cy > Cell.Radius * Cell.Radius * 1.2
			SetRotation(AimRotation)
			DrawImage AimImage,AimX - screenx,AimY - screeny
			SetRotation(0)
			Aimrotation = (Aimrotation + 1) Mod 360
		EndIf
		
		If maus2
			GotX = MausX
			GotY = MausY
			AimX = GotX + ScreenX
			AimY = GotY + ScreenY
			NewMove = True
		EndIf
		
		If lastmove + 2000 < MilliSecs() And NewMove
			cell.SetMoveManuell(GotX + screenx,GotY+ screeny)
			LastMove = MilliSecs()
			NewMove = False
		EndIf
		
End Function


