Global CellList:TList = New TList,Kern:TImage = imageload("kern")
Global Membran:TImage = imageload("Membran")
SetImageHandle(Membran,ImageWidth(Membran),ImageHeight(membran)/2)
Const RandomMoves:Int = 1,Neutral:Int = 1,Agressiv:Int = 2,Afrait:Int = 3,AgrCell:Int = 4
Type TCell Extends TGameobjekt
	
	Field Kx:Int,Ky:Int
	Field Gx:Int,Gy:Int
	Field Nodes:TList = New TList
	Field Organellen:TList = New TList
	Field CN:TNode
	Field NN:Int
	Field Behavior:Int
	Field Target:TGameObjekt
	Field Atp:Int
	Field Radius:Int
	Field image:TImage
	Field vec:Float[] = New Float[2]
	Field Enzyme:TList = New TList
	Field InnereOrganellen:Int
	Field distanz:Float
	Field LifeGui:TGui
	
	Field resourcen:Int[] = New Int[4]
	Field Power:Int = 1
	Field Life:Int = 100,MaxLife:Int = 100
	Field Speed:Float = 1
	Field Toxin:Int = 0
	Field Resistenz:Int = 0
	Field MeeleCD:Int
	
	Field Removed:Int
	
	Method Info:String()
		Return Maxlife + "\" + Resistenz + "\" + round(Speed,2) + "\" + Power + "\" + Toxin
	End Method
	
	Method sortOrganellen()
	
		Local z:Int = InnereOrganellen
		If z <= 0 Then Return
		Local count:Int = 0,winkel:Float,xd:Float,yd:Float
		Local ra:Float = 64
		For Local o:TOrganelle = EachIn Organellen
			count:+1
			winkel = (360/z) * count
			xd = 1
			yd = 1
			If (winkel Mod 180) 		Then xd = -1
			If (winkel + 90) Mod 180 	Then yd = -1
			o.x = xd * Sin(winkel) * ra
			o.y = yd * Cos(winkel) * ra
		Next
	End Method
	
	Method SetSpeed(S:Float)
		Speed:+ s
		For Local n:TNode = EachIn Nodes
			n.Stepwidth = speed
		Next
	End Method
	
	Method SetLife(l:Int,Maximum:Byte = 1)
		CreateMovingText(l + " Life",x,y)
		life:+ l
		MaxLife:+ l * Maximum
		If life <= 0 Then Remove()
	End Method
	
	Method RestoreLife(l:Int)
		Life = Min(Life + l,MaxLife)
	End Method
	
	Method SetPower(p:Int)
		power = p
	End Method
	
	Method Draw()
		Super.draw()
		Check()
		If Cell = Self Then LifeGui.Wert = Life + " / " + MaxLife
		Local dx:Int,dy:Int
		Local Moves:Int
		If show
			For Local N:TNode = EachIn Nodes
				n.draw()
				dx:+n.x
				dy:+n.y
				Moves:+ n.movecounter
			Next	
			
			SetRotation(0)
			SetScale(1,1)
			
			x = dx/NN
			y = dy/NN
			DrawImage image,x -screenx,y - screeny
			
			For Local o:TOrganelle = EachIn Organellen
				o.draw()
			Next	
			
			For Local E:TEnzym = EachIn enzyme
				e.draw()
				e.move()
			Next
			
			SetColor(255,255,255)
		EndIf
		If moves = 0
			setmove(sx,sy)
		EndIf
		
		If Dis(Cell) > GW * 1.5 Then remove()
		If Self <> Cell And Life < Maxlife
			SetColor 0,0,0
			DrawRect x-50 -screenx,y - 5 - screeny,100,10
			SetColor 0,255,0
			DrawRect x-50 - screenx,y - 5 - screeny,100 * (Float(Life)/Float(maxlife)),10
			SetColor 255,255,255
		EndIf
		
		Collide()
		Behave(moves)
	End Method
	
	Method Collide()
		For Local c:TCell = EachIn CellList
			If c <> Self And dis(c) < (Radius + c.radius) * 0.95
				If MeeleCD <= 0
					c.life:- Power
					MeeleCD = 30
					CreateMovingText("-" + Power + " Life",c.x,c.y)
					If C.life <= 0 Then c.Remove()
				Else
					MeeleCD:-1
				EndIf
			EndIf
		Next
	End Method
				
	
	Method AddSlicer()
		CreateEnzym(Self)
	End Method
	
	Method Setbehavior(B:Int)
		Behavior = b
		Select b
		Case RandomMoves
			setcolors(0,0,255)
		Case agressiv
			setcolors(255,0,0)
		Case afrait
			setcolors(255,0,255)
		End Select
	End Method
	
	Method Behave(moves:Int)
		If moves = 0 And cn.sx = cn.x And cn.sy = cn.y
			Select Behavior
			Case RandomMoves
				setmove(Rand(0,mapsize),Rand(0,Mapsize))
			Case AgrCell
				setMove(cell.x,cell.y)
			Case agressiv
				Local di:Float = 99999
				For Local c:TCell = EachIn Celllist
					If dis(c) < di And c <> Self
						target = c
						di = dis(c)
					EndIf 
					If target <> Null Then 
						setMove(target.x,target.y)
						TCell(target).Setbehavior(Afrait)
					EndIf
				Next
			Case afrait
				Local di:Float = 200
				For Local c:TCell = EachIn Celllist
					If dis(c) < di And c.behavior = Agressiv And c <> Self
						target = c
						di = dis(c)
					EndIf 
				Next
				If target <> Null Then 
					Local mx:Int = target.x - x
					Local my:Int = target.y - y
					setMove(x - mx,y-my)
				Else
					SetBehavior(1)
				EndIf
			End Select
			Move()
		EndIf
	End Method
	
	Method Move:Float[]()
		vec = Super.Move()
		For Local n:Tnode = EachIn nodes
			n.move() 
		Next
		Return vec
	End Method
	
	Method SetMoveManuell(Kx:Int,Ky:Int)
			Local plus:Int = Sqr((cn.x - cn.sx)^2 + (cn.y - cn.sy)^2)/10
			Setmove(kx,ky)	
			Local minus:Int = Int(distanz)/10
			resourcen[3]:+ (plus - minus)
				
		If resourcen[3] >= Int(distanz)/10 
			CreateMovingText((plus - minus) + " ATP",Kx,Ky)
		Else
			SetMove(Cn.x,Cn.y)
			CreateMovingText("Nicht genug ATP um hier hin zu gelangen...",Kx,Ky)
		EndIf
	End Method
	
	Method SetMove(Kx:Int,Ky:Int)
		Super.setMove(kx,ky)
		distanz = 99999
		For Local N:TNode = EachIn Nodes
			If n.dis2(sx,sy) < distanz Then 
				distanz = n.dis2(sx,sy)
				CN = n
			EndIf
		Next	
		cn.movecounter = NN
		cn.setmove(Kx,Ky)
	End Method
	
	Method PositionNodes(ra:Int = 100,Dir:Int = True)
	Local count:Int = 0,winkel:Float,xd:Float,yd:Float
		Radius = ra * 1.3
		For Local b:TNode = EachIn Nodes
			count:+1
			winkel = (360/NN) * count
			xd = 1
			yd = 1
			If (winkel Mod 180) 		Then xd = -1
			If (winkel + 90) Mod 180 	Then yd = -1
			b.sx = x + xd * Sin(winkel) * ra
			b.sy = y + yd * Cos(winkel) * ra
			If dir
				b.x = b.sx
				b.y = b.sy
			EndIf
			b.relx = b.sx - Self.x
			b.rely = b.sy - Self.y
		Next
	End Method 
	
	Method remove()
		If removed <> True
			ListRemove(Celllist,Self)
			CreateItem(x + Rand(-32,32),y + Rand(-32,32),100,0,0)
			CreateItem(x + Rand(-32,32),y + Rand(-32,32),0,2,0)
			CreateItem(x + Rand(-32,32),y + Rand(-32,32),0,0,Rand(1,2) * maxLife / 10)
			removed = true
		EndIf
	End Method
	
End Type

Function CreateCell:TCell(x:Int,y:Int,Nodes:Int,bh:Int = RandomMoves)
	If nodes Mod 2 = 0 Then nodes:+1
	Local c:TCell = New tcell
		c.init(x,y)
		c.Setbehavior(bh)
		c.image = Kern
		Local lastNode:Tnode = Null
		For Local i:Int = 1 To Nodes
			lastnode = CreateNode(LastNode,c)
			ListAddLast(c.Nodes,lastnode)
			lastnode.cell = c
			If i = nodes Then 
				lastnode.rn = tnode(c.nodes.first())
				Tnode(c.nodes.first()).ln = lastnode
			EndIf
		Next
		c.NN = c.nodes.count()
	ListAddLast(CellList,c)
	c.PositionNodes()
	c.cn = tnode(c.nodes.first())
	c.setmove(c.cn.x,c.cn.y)
	Return c
End Function

Function CompairCells()
	For Local C:TCell = EachIn Celllist
		If c <> Cell
			If c.power - 2 > cell.power
				c.Setbehavior(Agressiv)
			ElseIf c.power + 2 < cell.power
				c.Setbehavior(Afrait)
			Else
				c.Setbehavior(Neutral)
			EndIf
		EndIf
	Next
End Function
	
Function UpdateCells()
	For Local c:TCell = EachIn CellList
		c.update()
	Next
End Function
	
	
	
	
	
	
