Type TEnzym Extends TDGameObjekt
	Field Image:TImage
	Field relativX:Float
	Field RelativY:Float
	Field C:TCell
	
	Method Draw()
		Super.Draw()
		DrawImage image,x-screenx,y-screeny
	End Method
	
	Method Move:Float[]()
		If target <> Null
			setmove(Target.x,Target.y)
			
			If Dis(Target) < Stepwidth * 1.2
				target.remove()
				remove()
			EndIf
			
			If c.dis(Target) > c.radius Then 
				target = Null
				relativX = c.x - x
				relativY = c.y - y
			EndIf
		Else
			setmove(c.x + relativX,c.y + relativY)
		EndIf
		
		If dis(c) > c.radius
			sx = (c.x - x)/4
			sy = (c.y - y)/4
		EndIf
		Return Super.move()
	End Method
	
	Method Remove()
		Cell.resourcen[Amino]:+25
		ListRemove(c.enzyme,Self)
	End Method
End Type

Function DefendCell()
	For Local v:TVirus = EachIn InsideVirenList
		If v.attactedBy = Null Then 
			GetNearestFreeEnzym(v)
		EndIf
	Next
End Function

Function GetNearestFreeEnzym(V:TVirus)
	Local Dis:Float = 9999
	Local Nearest:TEnzym
	For Local e:TEnzym = EachIn Cell.Enzyme
		If e.target = Null And dis > e.dis(v) Then dis = e.dis(v) ; Nearest = e
	Next
	v.attactedby = nearest
	If nearest <> Null Then nearest.target = v
End Function

Function CreateEnzym:Tenzym(C:TCell)
	Local E:TEnzym = New TEnzym
		e.relativX = Rand(-c.Radius * 0.4,c.Radius * 0.4)
		e.RelativY = Rand(-c.Radius * 0.4,c.Radius * 0.4)
		e.init(c.x + e.RelativX,c.y + e.RelativY,2)
		e.x = c.x
		e.y = c.y
		e.c = c
		e.image = imageload("Enzym")
		e.setcolors(255,0,0)
	If c <> Null Then ListAddLast(C.Enzyme,e)
	Return e
End Function

Global ProduktionsListe:TList = New TList

Function MakeSlicer(c:TCell,ATPKosten:Int = 19,AminoKosten:Int = 25)
	If c.resourcen[ATP] >= ATPKosten And c.resourcen[AMINO] >= AminoKosten And c.resourcen[Nuclein] >= 1
		c.resourcen[ATP]:- ATPKosten
		c.resourcen[AMINO]:-AminoKosten
		c.resourcen[Nuclein]:- 1
		Local e:TEnzym = CreateEnzym(c)
		ListRemove(c.enzyme,e)
		e.c = c
		e.timer = 5 * 60
		ListAddLast(ProduktionsListe,e)
	EndIf
End Function

Function UpdateProduktion()
	For Local g:TDGameobjekt = EachIn ProduktionsListe
		If g.timer > 0
			g.timer:-1
		Else
			Local e:TEnzym = TEnzym(g)
			If  e <> Null
				ListAddLast(e.c.enzyme,e)
			EndIf
			e.c.resourcen[Nuclein]:+1
			ListRemove(ProduktionsListe,e)
		EndIf
	Next
End Function
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
