

Const Intra:Int = 0, Extra:Int = 1
Type TOrganelle Extends TGameobjekt
	
	Field Image:TImage
	Field Name:String
	Field Bind:TGameObjekt
	Field bh:Int
	Field Action(o:Torganelle)
	
	
	Method GetAngle:Int()
		Local n:TNode = TNode(Bind)
		If n = Null Return 0
		Return (ATan2(n.cell.y - n.y,n.cell.x - n.x) + 270) Mod 360
	End Method
	
	Method Draw()
		Super.draw()
		Select bh
		Case Intra
			DrawImage image,x + bind.x - screenx, y + bind.y - screeny
		Case Extra
			SetRotation(GetAngle())
			DrawImage image,bind.x - screenx,bind.y - screeny
			SetRotation(0)
		End Select
		If action <> Null
			Action(Self)
		EndIf
	End Method
	
	Method remove()
	End Method

	
	Method Copy()
		Local o:TOrganelle = New TOrganelle
		o.name = name
		o.image = image
		Select bh
		Case Intra
			o.Bind = Cell
			o.bh = Intra
		Case Extra
			Local t:TGameObjekt
			o.bind = TNode(Cell.Nodes.ValueAtIndex(Rand(2,Cell.Nodes.Count()-1)))
			o.x = 0
			o.y = 0
			o.sx = 0
			o.sy = 0
			o.bh = Extra
			SetImageHandle(o.image,ImageWidth(o.image)/2,ImageHeight(o.image))
		End Select
	o.setcolors(r,g,b)
	If o.image <> Null Then ListAddLast(cell.organellen,o)
	End Method
End Type

Function CreateOrganelle(Name:String)
	Local FP:FileParser = New FileParser
	Fp.Read("Data/" + Name + ".orga")
	Local o:TOrganelle = New TOrganelle,r:Int,b:Int,g:Int,anzahl:Int
		o.name = name
		While(fp.isempty() = False)
			Local t:Token = fp.gettoken()
			Select Lower(t.Identifier)
			Case "image"
				o.image = imageload(t.value)
			Case "bh"
				Select Int(t.value)
				Case Intra
					o.Bind = Cell
					o.bh = Intra
					cell.innereorganellen:+1
				Case Extra
					o.bind = TNode(Cell.Nodes.ValueAtIndex(Rand(1,Cell.Nodes.Count() - 1)))
					o.x = 0
					o.y = 0
					o.sx = 0
					o.sy = 0
					o.bh = Extra
					SetImageHandle(o.image,ImageWidth(o.image)/2,ImageHeight(o.image))
				End Select
			Case "red"
				r = Int(t.value)
			Case "blue"
				b = Int(t.value)
			Case "green"
				g = Int(t.value)
			Case "anzahl"
				anzahl = Int(T.Value)
			Case "function"
				Select Lower(t.value)
				Case "atp"
					o.action = ATPSynthase
				Case "slicer"
					o.action = Slicer
				Case "photosynthese"
					o.action = Photosynthese
				Case "geschwindigkeit"
					o.action = Geschwindigkeit
				Case "heilen"
					o.action = Heal
				Case "toxin"
					o.action = Toxin
				Case "improve"
					o.action = Improve
				End Select
			Case "attribut"
				Local a:String[] = SplitString(t.value)
				Select Lower(a[0])
				Case "life"
					cell.SetLife(Int(a[1]))
				Case "power"
					cell.power:+ Int(a[1])
				Case "resistenz"
					cell.resistenz:+ Int(a[1])
				Case "toxin"
					cell.toxin:+ Int(a[1])
				Case "speed"
					Cell.SetSpeed(Float(a[1]))
				End Select
			Case "changeimage"
				cell.image = imageload("kerner")
			End Select
			
		Wend
		
		o.setcolors(r,g,b)
	If o.image <> Null Then ListAddLast(cell.organellen,o)
	For Local i:Int = 1 To anzahl
			o.copy()
	Next
	cell.sortOrganellen()
End Function
		
	Function ATPSynthase(O:TOrganelle)
	Global CoolDown:Int = 60 * 4
		If CoolDown > 0
			CoolDown:-1
		ElseIf TCell(o.Bind).Resourcen[Glucose] > 0
			CoolDown = 60 * 4
			TCell(o.Bind).Resourcen[Glucose]:-1	
			TCell(o.Bind).Resourcen[ATP]:+38
			CreateMovingText("+38 ATP",GW/2 + Screenx,GH/2 + Screeny)
		EndIf	
	End Function
	
	Function Slicer(O:TOrganelle)
		Global Gui:TGui
		If Gui = Null 
			Gui = CreateGui(-1)
			Gui.name = "Slicer"
		Else
			If ProduktionsListe.isempty()
				Gui.wert = TCell(o.bind).enzyme.count() + " / 20"
			Else
				Gui.wert = TCell(o.bind).enzyme.count() + " + " + ProduktionsListe.count() + " / 20"
			EndIf
			If mouseoverlape(Gui.x - 64,Gui.y - 32,128,64) And Maus1
				MakeSlicer(Cell)
			EndIf
		EndIf
	End Function
	
	Function Heal(O:TOrganelle)
		Global Gui:TGui,Count:Float
		If Gui = Null 
			Gui = CreateGui(-1)
			Gui.name = "Reparieren"
		Else
			If Count = 0
				Gui.wert = ""
				If mouseoverlape(Gui.x - 64,Gui.y - 32,128,64) And Maus1
					If TCell(O.Bind).life = TCell(O.Bind).Maxlife
						CreateMovingText("Maximales Leben erreicht!",GW/2 + Screenx,GH/2 + Screeny)
					ElseIf TCell(O.Bind).resourcen[ATP] >= 40
						Count = 1
						TCell(O.Bind).resourcen[ATP]:-40
					Else
						CreateMovingText("40 ATP bentigt!",GW/2 + Screenx,GH/2 + Screeny)
					EndIf
				EndIf
			Else
				Gui.wert = Int(Count) + "%"
				Count:+0.5
				If Count >= 100
					TCell(O.Bind).RestoreLife(10)
					Count = 0
					CreateMovingText("+10 Leben",GW/2 + Screenx,GH/2 + Screeny)
				EndIf
			EndIf
			
		EndIf
	End Function
	
	Global PhotosyntheseEffizienz:Int = 10
	Function Photosynthese(O:TOrganelle)
		Global CoolDown:Int = 60 * 10
		If CoolDown > 0
			CoolDown:-1
		Else
			CoolDown = 60 * 10
			TCell(O.Bind).resourcen[Glucose]:+1
			CreateMovingText("+1 Glucose",GW/2 + Screenx,GH/2 + Screeny)
		EndIf
	End Function
	
	Function Geschwindigkeit(O:TOrganelle)
		Global CoolDown:Int = 0
		If CoolDown > 0
			CoolDown:-1
		ElseIf CoolDown < 0
			CoolDown:+1
			If CoolDown = 0 Then TNode(O.Bind).cell.SetSpeed(-2) ; CoolDown = 60 * 60
		Else
			If KeyHit(KEY_W) Then TNode(O.Bind).cell.SetSpeed(2) ; CoolDown = 60 * (-2)
		EndIf
	End Function
	
	Function Toxin(O:TOrganelle)
		Global CoolDown:Int = 0
		If Cooldown <= 0 And (KeyHit(Key_Q) Or Maus3) 
			CreateToxin(O)
			CoolDown = 75
		ElseIf CoolDown > 0
			cooldown:-1
		EndIf
	End Function
	
	Function Improve(O:Torganelle)
		PhotosyntheseEffizienz = 13
	End Function
		
		
		

		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
