Global Strich:TImage = imageload("Strich"),Skillinfo:TSkill
SetImageHandle(Strich,ImageWidth(Strich),ImageHeight(strich)/2)
Type Tree
	Field Value:TSkill
	Field n:Tree
	Field v:Tree
	Field Tiefe:Float
	
	Method Vergleich%(T:Tree)
		Return t.value.comp(Self.value)
	End Method
	
	
	Method Draw:String()
		Local re1:String,re2:String
		If n <> Null Then
			Select Value.Aktiv
			Case 0
				SetColor 150,150,150
			Case -1
				SetColor 50,50,50
			Case 1
				SetColor 255,255,255
			End Select 
			DrawimageLine(strich,value.x,value.y,n.value.x,n.value.y)
			re1 = n.draw()
		EndIf
		If v <> Null Then 
			Select Value.Aktiv
			Case 0
				SetColor 150,150,150
			Case -1
				SetColor 50,50,50
			Case 1
				SetColor 255,255,255
			End Select 
			DrawimageLine(Strich,value.x,value.y,v.value.x,v.value.y)
			re2 = v.draw()
		EndIf
		Return re1 + re2 + value.draw()
	End Method
	
	Method Add%(W:Tree) ' Methode die die Wurzel will und dann in den Baum einordnet
		Local relation:Int = Vergleich(w)
		w.tiefe:+1
		If relation = -1 Then
			If n = Null 
				n = w
			Else
				n.add(w)
			EndIf
		Else
			If v = Null
				v = w
			Else
				v.add(w)
			EndIf
		EndIf
	End Method
	
	Method Inorder:TList()
	 	Local List:TList = New TList
		inorder_in(list)
		Return list
	End Method
				
	Method Inorder_in(l:TList)
		If n <> Null Then n.inorder_in(l)
		ListAddFirst(l,Self)
		If v <> Null Then v.inorder_in(l)
		Return 
	End Method
	
	Method GivePositions(x:Int,y:Int,w:Int,h:Int)
		Local List:TList = Inorder()
		Local MaxTiefe:Float = 0,Knotenanzahl:Int = List.count(),counter:Int = 0
		For Local s:Tree = EachIn List
			MaxTiefe = Max(s.tiefe,MaxTiefe)
		Next
		
		For Local s:Tree = EachIn List
			s.value.x = x+ counter * (w/Knotenanzahl)
			s.value.y = y+ s.tiefe/MaxTiefe * h
			Counter:+1
		Next
	End Method


End Type

Function TreeMain()
	Local KY:Int = -GH,FY:Int = GH,MX:Int = -gw
	Local i:TImage = CreateImage(GraphicsWidth(),GraphicsHeight())
	GrabImage(i,0,0)
	Repeat
		Skillinfo = Null
		If KY < 100
			ky:+6
			Skilltree.GivePositions(50,ky,GW - 100,400)
		EndIf
		
		If MX < 0
			Mx:+ 6
		Else
			Mx = 0
		EndIf
		
		If FY > 0 
			FY:-4
		Else
			FY = 0
		EndIf
		DrawImage i,0,0
		DrawBackGroundTree(FY)
		DrawSkillTreeMenu(MX,GH * (3.0/4.0),gw,gh/4,SkillTree.draw())
		mouseupdate()
		
		If Skillinfo <> Null
			SetColor(0,0,0)
			SetAlpha(0.5)
			Local Tw:Int = TextWidth(Skillinfo.Name)
			Local Th:Int = TextHeight(Skillinfo.Name)
			DrawRect(Skillinfo.x - Tw/2 - 5,Skillinfo.y - th/2 - 1,tw + 10,th + 2)
			SetColor(255,255,255)
			SetAlpha(1)
			text2(Skillinfo.Name,Skillinfo.x,Skillinfo.y,1,1)
		EndIf
		
		Flip
		If AppTerminate() Then End
		Cls
		
	Until KeyHit(KEY_SPACE) Or KeyHit(KEY_ESCAPE)
		For Local i:Int = 0 To 400
			CreateBlubb(Rand(0,Gw),Rand(0,gh),3)
		Next
End Function

Function CreateTree:Tree(t:TSkill,AddWord:Tree = Null)
	Local A:Tree = New Tree
		a.Value = t
		t.node = a
		If addword <> Null Then addword.add(a)
	Return a
End Function

Function DrawBackGroundTree(Height:Int,r:Int = 80,g:Int = 255,b:Int = 80)
	SetColor(r,g,b)
	DrawRect(0,Height,gw,gh)
	Blubbs(300,3,Height - 16)
	SetColor(255,255,255)
End Function

Type TSkill
	Field x:Int,y:Int
	Field Name:String
	Field discription:String
	Field image:TImage
	Field Value:Int
	Field Aktiv:Int = -1
	Field Node:Tree
	Field Kosten:Int = 250
	
	Method SetAktiv(Bezahlen:Byte = True)
		If Bezahlen = True And kosten > cell.resourcen[3] Then Return
		Aktiv = 1
		If node <> Null
			If node.n <> Null Then node.n.value.aktiv = 0
			If node.v <> Null Then node.v.value.aktiv = 0
		EndIf
		If FileType("Data/"+Name+".orga") <> 0
			CreateOrganelle(Name)
		EndIf
		If Bezahlen = True Then Cell.resourcen[3]:-kosten
	End Method
	
	Method Draw:String()
		Select Aktiv
		Case 0
			SetColor 150,150,150
		Case -1
			SetColor 50,50,50
		Case 1
			SetColor 255,255,255
		End Select
		
		DrawImage image,x,y
		If mouseoverlape(x-32,y-32,64,64) Then 
			Skillinfo = Self
			If Maus1 And Aktiv = 0 Then
				SetAktiv()
			EndIf
			Return discription
		EndIf
		Return ""
	End Method
	
	Method comp:Int(t:TSkill)
		Local v:Int = (Value - T.Value)
		If v = 0 Then Return v
		Return v/Abs(v)
	End Method
End Type

Function ReadSkill:Tree()
	Local FP:FileParser = New FileParser
	Fp.Read("Data/Data.skill")
	
	Local s:TSkill= New TSkill
		s.image = imageload("skill")	
		s.name = "Zellkern" 
		s.discription = "Der Zellkern ist das Zentrum einer jeden Zell und vorallem wird in ihm die DNA aufbewahrt."
		s.value = 1000
		s.setaktiv(False)
	Local Tr:Tree = CreateTree:Tree(s)
		While(fp.isempty() = False)
			Local t:Token = fp.gettoken()
			Select Lower(t.Identifier)
			Case "beschreibung"
				s.discription = t.value
			Case "wert"
				s.value = Int(t.value)
				CreateTree(s,tr)
			Case "new"
				s:TSkill = New TSkill
				s.image = imageload("skill")	
				s.name = t.value 
			Case "kosten"
				s.kosten = Int(t.value)
			End Select
			
		Wend
		tr.n.value.aktiv = 0
		tr.v.value.aktiv = 0
	Return tr
End Function

Function CreateTSkill:TSkill(Wert:Int,Name:String,Beschreibung:String)
	Local s:TSkill = New TSkill
		s.name = name
		s.discription = Beschreibung
		s.Value = Wert
		s.image = imageload("skill")
		MidHandleImage(s.image)
	Return s
End Function
	

Function DrawSkillTreeMenu(x:Int,y:Int,w:Int,h:Int,InfoText:String)
	Local w2:Int = w* (2.5/3.0)
	SetAlpha(0.5)
	SetColor 0,0,0
	DrawRect x,y,w,h
	SetAlpha(1)
	SetColor 255,255,255
	SetScale(w/3,1)
	DrawImage Strich,x+w,y
	SetScale(h/3 + 2,1)
	SetRotation(270)
	DrawImage Strich,x+w2,y + 4
	SetRotation(0)
	SetScale(1,1)
	Textarea(InfoText,x+5,y+5,w2-5,h-5)
	TextArea("Leben:\Resistenz:\Speed:\Strk:\Toxin",x + w2 + 5,y + 5, w - w2,h - 5)
	Textarea(Cell.info(),x + w - 35,y + 5, w - w2,h - 5)
End Function
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
