SuperStrict


'============================================== Types ===============================================

'Player-Type .. jaja, es gibt nur einen Spieler, aber ich packe ihn trotzdem in ein Type und zwar weil ich kann
Type TPlayer
	
	Field X:Byte			'X-Position
	Field Y:Byte			'Y-Position
	
	Field VX:Byte			'X-Geschwindigkeit
	Field VY:Byte			'Y-Geschwindigkeit
	
	Field Color:Byte		'Farbe
	
	Field Moves:Short		'Moves im gesamten Spiel
	Field MovesTry:Short	'Moves beim aktuellen Versuch
	Field Resets:Short		'Resets im gesamten Spiel
	
	'Init-Methode
	Method Init( X:Byte , Y:Byte )
		
		Self.X = X
		Self.Y = Y
		
		Self.VX = 0
		Self.VY = 0
		
		Self.Color = COLOR_NONE
		
		Self.MovesTry = 0
		
	End Method
	
	'Update-Methode
	Method Update()
		
		'Usereingabe
		If Self.VX = 0 And Self.VY = 0
			
			Local Dir:Byte
			If KeyHit( KEY_LEFT ) And Self.X > 0 And Map.Tiles[ Self.X - 1, Self.Y ] <> 1 Then Dir = 1
			If KeyHit( KEY_RIGHT ) And Self.X < Map.Width And Map.Tiles[ Self.X + 1, Self.Y ] <> 1 Then Dir = 2
			If KeyHit( KEY_UP )	And Self.Y > 0 And Map.Tiles[ Self.X, Self.Y - 1 ] <> 1 Then Dir = 3
			If KeyHit( KEY_DOWN ) And Self.Y < Map.Height And Map.Tiles[ Self.X, Self.Y + 1 ] <> 1 Then Dir = 4 
			
			Select Dir
				Case 1 ; Self.VX = -1
				Case 2 ; Self.VX = 1
				Case 3 ; Self.VY = -1
				Case 4 ; Self.VY = 1
			End Select
			
			If Not Dir = 0 Then Self.Moves :+ 1 ; Self.MovesTry :+ 1
			
		End If
		
		If KeyHit( KEY_R ) Then
			Map.Init( Map.NR )
			Self.Resets :+ 1
		End If
		
		FlushKeys()
		
		'Bewegen
		Local OldX:Byte = Self.X
		Local OldY:Byte = Self.Y
		
		Self.X :+ Self.VX
		Self.Y :+ Self.VY
		
		'Kollisionen
		Local TileValue:Byte = Map.Tiles[ Self.X, Self.Y ]
		
		Select TileValue
			
			'Hier ist Ende Gelnde.
			Case 1
				Self.X = OldX
				Self.Y = OldY
				Self.VX = 0
				Self.VY = 0
			
			'Kollision mit / oder \
			Case 3, 4
				Local NewVX:Byte = Self.VY * ( ( TileValue = 3 ) * -2 + 1 )
				Local NewVY:Byte = Self.VX * ( ( TileValue = 3 ) * -2 + 1 )
				Self.VX = NewVX
				Self.VY = NewVY
				
			'Ziel
			Case 5
				If PaintedEverything = True Then
					If Map.Init( Map.NR + 1 ) = False Then
						Repeat
							
							DrawText "Genial, Sie haben gewonnen!", 150, 150
							If Self.Resets <> 1 Then
								DrawText "Sie haben " + Self.Moves + " Zuege und " + Self.Resets + " Resets gebraucht.", 150, 170
							Else
								DrawText "Sie haben " + Self.Moves + " Zuege und 1 Reset gebraucht.", 150, 170
							End If
							
							WaitTimer timer
							Flip 0
							Cls
							
						Until GetChar() <> 0
						End
					End If
				End If
				
			'Anmaldingen
			Case 10, 11, 12, 13
				If Self.Color = TileValue - 9 Then
					Map.Tiles[ Self.X, Self.Y ] = 19 + Self.Color
					PaintedEverything = Map.CheckPaint()
				End If
				
			'Angemaltes Anmaldingen
			Case 20, 21, 22, 23
				If Self.Color <> TileValue - 19 And Self.Color <> COLOR_NONE Then
					Map.Tiles[ Self.X, Self.Y ] = TileValue - 10
					PaintedEverything = Map.CheckPaint()
				End If
				
			'Farbe
			Case 30, 31, 32, 33
				Self.Color = TileValue - 29
			
		End Select
		
	End Method
	
	'Render-Methode
	Method Render()
		
		Select Self.Color
			
			Case COLOR_NONE 	; 	SetColor 255,	255,	255
			Case COLOR_RED 	; 	SetColor 255,	0, 	0
			Case COLOR_BLUE	; 	SetColor 0,	0,	255
			Case COLOR_GREEN	; 	SetColor 0,	255,	0
			Case COLOR_YELLOW	; 	SetColor 255,	255,	0
			
		End Select
		
		DrawRect Self.X * Tilesize, Self.Y * Tilesize, Tilesize + 1, Tilesize + 1
		
		SetColor 255, 255, 255
		
		DrawText "Zuege ( Versuch ): " + Self.MovesTry, Tilesize, - 50
		DrawText "Zuege gesamt: " + Self.Moves, Tilesize, - 30
		DrawText "Resets: " + Self.Resets, Tilesize, - 10
		
	End Method
	
End Type


'Map-Type .. jaja es gibt immer nur eine map .. etc blabla
Type TGameMap
	
	Field Tiles:Byte[ , ]		'Die Tiles in der Map
	Field Width:Byte			'Breite
	Field Height:Byte			'Hoehe
	Field NR:Byte
	
	'Init-Methode
	Method Init:Byte( NR:Byte )
		
		Self.NR = NR
		
		Self.Width = 0
		Self.Height = 0
		
		PaintedEverything = 0
		
		Local Filestream:TStream = ReadFile("maps\" + NR + ".map")
		
		If Filestream = Null Then Return False
		Filestream.ReadInt() '* Gitter berlesen
		Filestream.ReadInt()
		Self.Width = Byte(Filestream.ReadInt()) - 1
		Self.Height = Byte(Filestream.ReadInt()) - 1
		
		Self.Tiles = New Byte[ Width + 1, Height + 1 ]
		For Local x:Int = 0 To Self.Width
			For Local y:Int = 0 To Self.Height
				If Filestream.Eof() Then Return False
				Self.Tiles[x, y] = GetValue(Byte(Filestream.ReadInt()))
				If Self.Tiles[x, y] = 2 Then
					Self.Tiles[ X, Y ] = 0
					Player.Init( X, Y )
				End If
			Next
		Next
		
		CloseFile Filestream
		
		PaintedEverything = Self.CheckPaint()
		
		Return True
		
	End Method
	
	'Update-Methode
	Method Update()
		
		
		
	End Method
	
	'Render-Methode
	Method Render()
		
		For Local X:Byte = 0 To Self.Width
			
			For Local Y:Byte = 0 To Self.Height
				
				Select Self.Tiles[ X, Y ]
					
					Case 0	' begehbar
						Self.DrawTileZero( X, Y )
						
					Case 1	' nicht begehbar -> schwarz (nichts)
					
					Case 3	' /
						DrawLine X * Tilesize, Y * Tilesize + Tilesize, X * Tilesize + Tilesize, Y * Tilesize
						Self.DrawTileZero( X, Y )
						
					Case 4	' \
						DrawLine X * Tilesize, Y * Tilesize, X * Tilesize + Tilesize, Y * Tilesize + Tilesize
						Self.DrawTileZero( X, Y )
						
					Case 5	' Ziel ( -> )
						If PaintedEverything = True Then SetColor Rand( 255 ), Rand( 255 ), Rand( 255 )
						DrawLine X*Tilesize,Y*Tilesize+Tilesize/2,X*Tilesize+Tilesize,Y*Tilesize+Tilesize/2
						DrawLine X*Tilesize+Tilesize/2,Y*Tilesize,X*Tilesize+Tilesize,Y*Tilesize+Tilesize/2
						DrawLine X*Tilesize+Tilesize/2,Y*Tilesize+Tilesize,X*Tilesize+Tilesize,Y*Tilesize+Tilesize/2
						SetColor 255, 255, 255
						Self.DrawTileZero( X, Y )
						
					Case 10, 11, 12, 13			'Anmalding
						Select Self.Tiles[ X, Y ]
							Case 10 ;	SetColor 255, 0, 0
							Case 11 ; SetColor 0, 0, 255
							Case 12 ; SetColor 0, 255, 0
							Case 13 ; SetColor 255, 255, 0
						End Select
						DrawLine X*Tilesize, Y*Tilesize, X*Tilesize+Tilesize, Y*Tilesize+Tilesize
						DrawLine X*Tilesize, Y*Tilesize+Tilesize, X*Tilesize+Tilesize, Y*Tilesize
						SetColor 255, 255, 255
						Self.DrawTileZero( X, Y )
						
					Case 20, 21, 22, 23			' ausgeflltes rotes Anmalding
						Select Self.Tiles[ X, Y ]
							Case 20 ;	SetColor 255, 0, 0
							Case 21 ; SetColor 0, 0, 255
							Case 22 ; SetColor 0, 255, 0
							Case 23 ; SetColor 255, 255, 0
						End Select
						DrawRect X*Tilesize, Y*Tilesize, Tilesize, Tilesize
						SetColor 255, 255, 255
						Self.DrawTileZero( X, Y )
						
					Case 30, 31, 32, 33			'Farbe
						Select Self.Tiles[ X, Y ]
							Case 30 ;	SetColor 255, 0, 0
							Case 31 ; SetColor 0, 0, 255
							Case 32 ; SetColor 0, 255, 0
							Case 33 ; SetColor 255, 255, 0
						End Select
						DrawOval X*Tilesize, Y*Tilesize, Tilesize, Tilesize
						SetColor 255, 255, 255
						Self.DrawTileZero( X, Y )
						
				End Select
				
			Next
			
		Next
		
	End Method
	
	'Methode, die ein begehbares Tile zeichnet
	Method DrawTileZero( X:Byte, Y:Byte )
		Local X1:Short = X * Tilesize
		Local X2:Short = X * Tilesize + Tilesize
		Local Y1:Short = Y * Tilesize
		Local Y2:Short = Y * Tilesize + Tilesize
		If Y > 0 And Self.Tiles[ X, Y - 1 ] = 1 Then DrawLine X1, Y1, X2, Y1
		If Y < Self.Height And Self.Tiles[ X, Y + 1 ] = 1 Then DrawLine X1, Y2, X2, Y2
		If X > 0 And Self.Tiles[ X - 1, Y ] = 1 Then DrawLine X1, Y1, X1, Y2
		If X < Self.Width And Self.Tiles[ X + 1, Y ] = 1 DrawLine X2, Y1, X2, Y2
	End Method
	
	'Methode die beim Laden einer Map Zahlenwert liefert, wenn Buchstabe gegeben ist
	Method GetValue:Byte(C:Byte)
		
		Select C
			
			Case 8  'Magenta '"S"
				Return 2
				
			Case 1 ' "/"
				Return 3
				
			Case 2 '"\"
				Return 4
			Case 3
				Return 1
			Case 14 '"T"
				Return 5
				
			Case 7 'Rot "a"
				Return 10
				
			Case 4 'Blau "b"
				Return 11
				
			Case 5 'Grn "c"
				Return 12
				
			Case 9 'Gelb "d"
				Return 13
				
			Case 13 '"A"
				Return 30
				
			Case 10 '"B"
				Return 31
				
			Case 11 '"C"
				Return 32
				
			Case 15 '"D"
				Return 33
				
			Default
				Return 0
				
		End Select
		
	End Method
	
	'Methode die schaut, ob alle anzumalenden Tiles angemalt wurden
	Method CheckPaint:Byte()
		
		For Local X:Byte = 0 To Self.Width
			
			For Local Y:Byte = 0 To Self.Height
				
				Local V:Byte = Self.Tiles[ X, Y ]
				If V = 10 Or V = 11 Or V = 12 Or V = 13 Then Return False
				
			Next
			
		Next
		
		Return True
		
	End Method
	
End Type

'============================================= Consts ===============================================

'Farben
Const COLOR_NONE:Byte = 0
Const COLOR_RED:Byte = 1
Const COLOR_BLUE:Byte = 2
Const COLOR_GREEN:Byte = 3
Const COLOR_YELLOW:Byte = 4
'Const COLOR_ERASER = 5


'Tilegroesse in Pixel
Global Tilesize:Byte = 24


'============================================= Globals ==============================================

'Timer
Global Timer:TTimer


'Ob das Programm beendet werden soll
Global EndProgram:Byte


'Spieler
Global Player:TPlayer


'Map
Global Map:TGameMap


'Ob man alle Dinger angemalt hat
Global PaintedEverything:Byte


' === Init-Funktion aufrufen ===
Init()


'============================================= Mainloop =============================================

Repeat
	
	'Alles updaten
	Update()
	
	'Alles rendern
	Render()
	
	'blah
	WaitTimer Timer
	Flip 0
	Cls
	
	If AppTerminate() Or KeyHit(KEY_ESCAPE) Then EndProgram = True
	
Until EndProgram = True


'============================================ Funktionen ============================================

'Init-Funktion
Function Init()
	
	AppTitle = "ColorDot by Tennisball"
	
	Graphics 800, 600
	
	SetOrigin 0, 60
	
	Timer = CreateTimer( 60 )
	
	Player = New TPlayer
	
	Map = New TGameMap
	Map.Init( 1 )
	
End Function


'Update-Funktion
Function Update()
	
	Local mzs:Int = MouseZSpeed()
	Tilesize = Tilesize - ( mzs < 0 ) + ( mzs > 0 )
	If Tilesize < 2 Then Tilesize = 2
	If Tilesize > 64 Then Tilesize = 64
	
	Player.Update()
	
End Function


'Render-Funktion
Function Render()
	
	Player.Render()
	
	Map.Render()
	
End Function